#!/usr/bin/python

from PyQt4 import QtGui, QtCore, Qt
from ui_led_uSw import Ui_ExLed_uSw
from time import sleep
from pyfirmata import Arduino, util
#import sys

class ginyLed_uSw(QtGui.QWidget, Ui_ExLed_uSw):
	def __init__(self, parent=None, f=QtCore.Qt.WindowFlags()):
		QtGui.QWidget.__init__(self, parent, f)
		self.setupUi(self)
		
		self.ledB7 = 13		# P2b7
		self.ledB6 = 12		# P2b6
		self.ledB5 = 11		# P2b5
		self.ledB4 = 10		# P2b4
		self.uSwB3 = 9 		# P2b3
		self.uSwB2 = 8 		# P2b2
		#self.uSwB1 = 18	# P2b1
		#self.uSwB0 = 19	# P2b0
		self.uSwB1 = 4		# P2b1 as analog
		self.uSwB0 = 5		# P2b0 as analog
		#self.ledB7 = 7		# P1b7
		#self.ledB6 = 6		# P1b6
		#self.ledB5 = 5		# P1b5
		#self.ledB4 = 4		# P1b4
		#self.uSwB3 = 17	# P1b3
		#self.uSwB2 = 16	# P1b2
		#self.uSwB1 = 15	# P1b1
		#self.uSwB0 = 14	# P1b0
		
		self.board = Arduino('/dev/ttyUSB0')

		self.cfgB3 = 'd:' + str(self.uSwB3) + ':i'
		self.cfgB2 = 'd:' + str(self.uSwB2) + ':i'
		self.board.get_pin(self.cfgB3)
		self.board.get_pin(self.cfgB2)
		self.board.digital[self.uSwB3].enable_reporting()
		self.board.digital[self.uSwB2].enable_reporting()
		
		self.cfgB1 = 'a:' + str(self.uSwB1) + ':i'
		self.cfgB0 = 'a:' + str(self.uSwB0) + ':i'
		self.board.get_pin(self.cfgB1)
		self.board.get_pin(self.cfgB0)
		self.board.analog[self.uSwB1].enable_reporting()
		self.board.analog[self.uSwB0].enable_reporting()

		iterator = util.Iterator(self.board)
		iterator.start()
		
		self.iniciaTitol()
		self.checkBoxLedBit7.clicked.connect(self.miraCheckBox7)
		self.checkBoxLedBit6.clicked.connect(self.miraCheckBox6)
		self.checkBoxLedBit5.clicked.connect(self.miraCheckBox5)
		self.checkBoxLedBit4.clicked.connect(self.miraCheckBox4)
		self.btSurt.clicked.connect(self.cleanup)
		print "Per acabar del tot premeu Ctrl Z"
		self.timer = QtCore.QTimer()
		self.connect(self.timer, QtCore.SIGNAL("timeout()"), self.temporitzada)
		self.timer.start(500)	
		
	def __del__(self):
		self.cleanup

	def iniciaTitol(self):
		self.setWindowTitle("CheckBox");

	def miraCheckBox7(self, state): 
		if self.checkBoxLedBit7.isChecked():
			#print 'bit 7 ON'
			self.board.digital[self.ledB7].write(1)
		else:
			#print 'bit 7 OFF'
			self.board.digital[self.ledB7].write(0)

	def miraCheckBox6(self, state): 
		if self.checkBoxLedBit6.isChecked():
			#print 'bit 6 ON'
			self.board.digital[self.ledB6].write(1)
		else:
			#print 'bit 6 OFF'
			self.board.digital[self.ledB6].write(0)
			
	def miraCheckBox5(self, state):
		self.board.digital[self.ledB5].write(state)

	def miraCheckBox4(self, state):
		self.board.digital[self.ledB4].write(state)
		

	def cleanup(self):
		print "cleanup"
		self.board.digital[self.ledB7].write(0)
		self.board.digital[self.ledB6].write(0)
		self.board.digital[self.ledB5].write(0)
		self.board.digital[self.ledB4].write(0)
		#sleep(0.2)
		self.board.exit()
		sleep(0.8)
		self.close()
		#sys.exit(0)
		
	def temporitzada(self):		
		'''
		value3 = str(self.board.digital[self.uSwB3].read())
		value2 = str(self.board.digital[self.uSwB2].read())
		value1 = str(self.board.analog[self.uSwB1].read())
		value0 = str(self.board.analog[self.uSwB0].read())
		print 'B3 : ' + value3 + ', B2 : ' + value2 + ', B1 : ' + value1 + ', B0 : ' + value0	
		'''
		if self.board.digital[self.uSwB3].read() :
			self.checkBox_uSwBit3.setCheckState(1)
		else :
			self.checkBox_uSwBit3.setCheckState(0)
		if self.board.digital[self.uSwB2].read() :
			self.checkBox_uSwBit2.setCheckState(1)
		else :
			self.checkBox_uSwBit2.setCheckState(0)
		if (self.board.analog[self.uSwB1].read() > 0.5) :
			self.checkBox_uSwBit1.setCheckState(1)
		else :
			self.checkBox_uSwBit1.setCheckState(0)
		if (self.board.analog[self.uSwB0].read() > 0.5) :
			self.checkBox_uSwBit0.setCheckState(1)
		else :
			self.checkBox_uSwBit0.setCheckState(0)


if __name__ == '__main__':
	import sys

	app = QtGui.QApplication(sys.argv)
	window = ginyLed_uSw()
	window.resize(150,400)
	window.show()

	sys.exit(app.exec_())
